(function() {
    describe('jquery.qeeree._parse', function() {
        it('should parse an empty string', function () {
            $.qeeree._parse('');
            expect($.qeeree.get('abc')).toEqual(undefined);
        });
        it('should parse a single pair', function () {
            $.qeeree._parse('a=b');
            expect($.qeeree.get('a')).toEqual('b');
        });
        it('should parse multiple values', function () {
            $.qeeree._parse('a=b&c=d');
            expect($.qeeree.get('a')).toEqual('b');
            expect($.qeeree.get('c')).toEqual('d');
        });
        it('should return an empty string for an empty param value.', function () {
            $.qeeree._parse('a=');
            expect($.qeeree.get('a')).toEqual('');
        });
        it('should return an empty string for an empty param value when there is more than one value.', function () {
            $.qeeree._parse('a=&b=c');
            expect($.qeeree.get('a')).toEqual('');
            expect($.qeeree.get('b')).toEqual('c');
        });
        it('should deal well with values containing "="', function () {
            $.qeeree._parse('a=b=c');
            expect($.qeeree.get('a')).toEqual('b=c');
        });
    });


    describe('jquery.qeeree.getKeys', function() {
        it('should return all keys', function() {
            $.qeeree._parse('a=alphabet&b=bee&c=cheese&d=doughnut');
            $.each(['a','b','c','d'], function(index, item) {
                expect($.qeeree.getKeys()).toContain(item);
            });
        });
    });
})();

